﻿using System.Collections;

using DevExpress.Xpf.Grid;

namespace HowToImplementHierarchicalDataBinding
{
    /// <summary>
    /// 커스텀 자식 노드 셀렉터
    /// </summary>
    public class CustomChildNodesSelector : IChildNodesSelector
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 자식 선택하기 - SelectChildren(item)

        /// <summary>
        /// 자식 선택하기
        /// </summary>
        /// <param name="item">항목</param>
        /// <returns>IEnumerable 객체</returns>
        public IEnumerable SelectChildren(object item)
        {
            if(item is Task)
            {
                return null;
            }
            else if(item is ProjectStage)
            {
                return (item as ProjectStage).TaskCollection;
            }
            else if(item is ProjectObject)
            {
                return (item as ProjectObject).ProjectStageCollection;
            }

            return null;
        }

        #endregion
    }
}