﻿using System;
using System.Collections.ObjectModel;

namespace HowToImplementHierarchicalDataBinding
{
    /// <summary>
    /// 뷰 모델
    /// </summary>
    public class ViewModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 프로젝트 객체 컬렉션 - ProjectObjectCollection

        /// <summary>
        /// 프로젝트 객체 컬렉션
        /// </summary>
        public ObservableCollection<ProjectObject> ProjectObjectCollection { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public ViewModel()
        {
            ProjectObjectCollection = InitializeProjectObjectCollection();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Betaron 프로젝트 객체 초기화 하기 - InitializeBetaronProjectObject(projectObject)

        /// <summary>
        /// Betaron 프로젝트 객체 초기화 하기
        /// </summary>
        /// <param name="projectObject">프로젝트 객체</param>
        private void InitializeBetaronProjectObject(ProjectObject projectObject)
        {
            projectObject.Executor = "Mcfadyen Ball";

            ProjectStage projectStage21 = new ProjectStage()
            {
                Name           = "Information Gathering",
                Executor       = "Kaiden Savastano",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage21.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Market research",
                    Executor  = "Carmine Then",
                    StartDate = new DateTime(2011, 10, 1),
                    EndDate   = new DateTime(2011, 10, 5),
                    State     = StateList.DataSource[2]
                }
            );

            projectStage21.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Making specification",
                    Executor  = "Seto Kober",
                    StartDate = new DateTime(2011, 10, 5),
                    EndDate   = new DateTime(2011, 10, 10),
                    State     = StateList.DataSource[1]
                }
            );

            ProjectStage projectStage22 = new ProjectStage()
            {
                Name           = "Planning",
                Executor       = "Manley Difrancesco",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage22.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Documentation",
                    Executor  = "Martez Gollin",
                    StartDate = new DateTime(2011, 10, 15),
                    EndDate   = new DateTime(2011, 10, 16),
                    State     = StateList.DataSource[0]
                }
            );

            ProjectStage projectStage23 = new ProjectStage()
            {
                Name           = "Design",
                Executor       = "Clint Mary",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage23.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Design of a web pages",
                    Executor  = "Gasper Hartsell",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            projectStage23.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Pages layout",
                    Executor  = "Shirish Huminski",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            ProjectStage projectStage24 = new ProjectStage()
            {
                Name           = "Development",
                Executor       = "Edwin Thone",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage24.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Design",
                    Executor  = "Zarko Knill",
                    StartDate = new DateTime(2011, 10, 27),
                    EndDate   = new DateTime(2011, 10, 28),
                    State     = StateList.DataSource[0]
                }
            );

            projectStage24.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Coding",
                    Executor  = "Harley Kirckof",
                    StartDate = new DateTime(2011, 10, 29),
                    EndDate   = new DateTime(2011, 10, 30),
                    State     = StateList.DataSource[0]
                }
            );

            ProjectStage projectStage25 = new ProjectStage()
            {
                Name           = "Testing and Delivery",
                Executor       = "Boucher Hislop",
                TaskCollection = new ObservableCollection<Task>()
            };
            
            projectStage25.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Testing",
                    Executor  = "Sarah Ragas",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            projectStage25.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Content",
                    Executor  = "Rashid Terinoni",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            projectObject.ProjectStageCollection.Add(projectStage21);
            projectObject.ProjectStageCollection.Add(projectStage22);
            projectObject.ProjectStageCollection.Add(projectStage23);
            projectObject.ProjectStageCollection.Add(projectStage24);
            projectObject.ProjectStageCollection.Add(projectStage25);
        }

        #endregion
        #region Stantone 프로젝트 객체 초기화 하기 - InitializeStantoneProjectObject(projectObject)

        /// <summary>
        /// Stantone 프로젝트 객체 초기화 하기
        /// </summary>
        /// <param name="projectObject">프로젝트 객체</param>
        private void InitializeStantoneProjectObject(ProjectObject projectObject) 
        {
            projectObject.Executor = "Ruben Ackerman";

            ProjectStage projectStage11 = new ProjectStage()
            {
                Name           = "Information Gathering",
                Executor       = "Huyen Trinklein",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage11.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Market research",
                    Executor  = "Tanner Crittendon",
                    StartDate = new DateTime(2011, 10, 1),
                    EndDate   = new DateTime(2011, 10, 5),
                    State     = StateList.DataSource[2]
                }
            );

            projectStage11.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Making specification",
                    Executor  = "Carmine Then",
                    StartDate = new DateTime(2011, 10, 5),
                    EndDate   = new DateTime(2011, 10, 10),
                    State     = StateList.DataSource[2]
                }
            );

            ProjectStage projectStage12 = new ProjectStage()
            {
                Name           = "Planning",
                Executor       = "Alfredo Sookoo",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage12.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Documentation",
                    Executor  = "Gorf Wobbe",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[2]
                }
            );

            ProjectStage projectStage13 = new ProjectStage()
            {
                Name           = "Design",
                Executor       = "Saphire Plump",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage13.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Design of a web pages",
                    Executor  = "Dominic Minden",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[1]
                }
            );

            projectStage13.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Pages layout",
                    Executor  = "Pinkerton Trezise",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[1]
                }
            );

            ProjectStage projectStage14 = new ProjectStage()
            {
                Name           = "Development",
                Executor       = "Lauren Partain",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage14.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Design",
                    Executor  = "Delilah Beamer",
                    StartDate = new DateTime(2011, 10, 23),
                    EndDate   = new DateTime(2011, 10, 24),
                    State     = StateList.DataSource[1]
                }
            );

            projectStage14.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Coding",
                    Executor  = "Dunaway Dupriest",
                    StartDate = new DateTime(2011, 10, 25),
                    EndDate   = new DateTime(2011, 10, 26),
                    State     = StateList.DataSource[0]
                }
            );

            ProjectStage projectStage15 = new ProjectStage()
            {
                Name           = "Testing and Delivery",
                Executor       = "Christos Arrant",
                TaskCollection = new ObservableCollection<Task>()
            };

            projectStage15.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Testing",
                    Executor  = "Grice Ohora",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            projectStage15.TaskCollection.Add
            (
                new Task()
                {
                    Name      = "Content",
                    Executor  = "Christos Arrant",
                    StartDate = new DateTime(2011, 10, 13),
                    EndDate   = new DateTime(2011, 10, 14),
                    State     = StateList.DataSource[0]
                }
            );

            projectObject.ProjectStageCollection.Add(projectStage11);
            projectObject.ProjectStageCollection.Add(projectStage12);
            projectObject.ProjectStageCollection.Add(projectStage13);
            projectObject.ProjectStageCollection.Add(projectStage14);
            projectObject.ProjectStageCollection.Add(projectStage15);
        }

        #endregion
        #region 프로젝트 객체 컬렉션 초기화 하기 - InitializeProjectObjectCollection()

        /// <summary>
        /// 프로젝트 객체 컬렉션 초기화 하기
        /// </summary>
        /// <returns>프로젝트 객체 컬렉션</returns>
        private ObservableCollection<ProjectObject> InitializeProjectObjectCollection()
        {
            ObservableCollection<ProjectObject> projectObjectCollection = new ObservableCollection<ProjectObject>();

            ProjectObject betaronProject = new ProjectObject()
            {
                Name = "Project : Betaron",
                ProjectStageCollection = new ObservableCollection<ProjectStage>()
            };

            ProjectObject stantoneProject = new ProjectObject()
            {
                Name = "Project : Stanton",
                ProjectStageCollection = new ObservableCollection<ProjectStage>()
            };

            InitializeBetaronProjectObject (betaronProject );
            InitializeStantoneProjectObject(stantoneProject);

            projectObjectCollection.Add(betaronProject );
            projectObjectCollection.Add(stantoneProject);

            return projectObjectCollection;
        }

        #endregion
    }
}